'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ReduxAppController = require('./ReduxAppController');

var _ReduxAppController2 = _interopRequireDefault(_ReduxAppController);

var _Utils = require('./Utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AbstractComponent = function (_React$Component) {
	_inherits(AbstractComponent, _React$Component);

	function AbstractComponent() {
		_classCallCheck(this, AbstractComponent);

		var _this = _possibleConstructorReturn(this, (AbstractComponent.__proto__ || Object.getPrototypeOf(AbstractComponent)).call(this));

		_this._element = null;

		_this.init = _this.init.bind(_this);
		_this.getDomElement = _this.getDomElement.bind(_this);
		_this.saveRefToDomElement = _this.saveRefToDomElement.bind(_this);
		_this.getController = _this.getController.bind(_this);

		_this.init();
		return _this;
	}

	_createClass(AbstractComponent, [{
		key: 'init',
		value: function init() {}

		/**
   * Returns the element bound to this component by ref with a saveRefToDomElement() method.
   * @returns {HtmlElement}
   */

	}, {
		key: 'getDomElement',
		value: function getDomElement() {
			return this._element;
		}

		/**
   * The callback to bind the rendered DOM element to this component.
   * Usage: <MyComponent ref={this.saveRefToDomElement} />.
   * @param {HtmlElement}
   */

	}, {
		key: 'saveRefToDomElement',
		value: function saveRefToDomElement(element) {
			this._element = element;
		}

		/**
   * Returns the controller passed to this component in the "controller" property.
   * @returns {ReduxAppController}
   */

	}, {
		key: 'getController',
		value: function getController() {
			if (this.props.controller instanceof _ReduxAppController2.default) {
				return this.props.controller;
			}

			_Utils.Utils.fatalError('AbstractComponent', 'No controller passed to this component!');

			return undefined;
		}
	}]);

	return AbstractComponent;
}(_react2.default.Component);

exports.default = AbstractComponent;