'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _redux = require('redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ReduxAppControllerComponent = require('./ReduxAppControllerComponent');

var _ReduxAppControllerComponent2 = _interopRequireDefault(_ReduxAppControllerComponent);

var _ReduxAppControllerRouter = require('./ReduxAppControllerRouter');

var _Utils = require('./Utils');

var _Utils2 = _interopRequireDefault(_Utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var THROW_METHOD_PREFIX = 'throw';
var HANDLE_METHOD_PREFIX = 'handle';
var REDUCE_METHOD_PREFIX = 'reduceOn';

var ReduxAppController = function () {
	function ReduxAppController() {
		_classCallCheck(this, ReduxAppController);

		//super();
		/**
  if (new.target === ReduxAppController) {
  	throw new TypeError("You must not construct ReduxAppController instances directly.");
  }
  */
		if (this.getStateInitialData === undefined) {
			_Utils2.default.fatalError('ReduxAppController', "You must override method getStateInitialData() in a child of ReduxAppController.");
		}
		if (this.render === undefined) {
			_Utils2.default.fatalError('ReduxAppController', "You must implement method render() in a child of ReduxAppController.");
		}

		this.store = {};
		this.router = undefined;
		this.router_routes = undefined;
		this._action_types = [];

		this.initProperties();

		this._joinControllerComponent = this._joinControllerComponent.bind(this);
		this._joinComponents = this._joinComponents.bind(this);

		this.init();

		this.render = this.render.bind(this);
		this.init = this.init.bind(this);
		this.getActionTypes = this.getActionTypes.bind(this);
		this.getControllerComponents = this.getControllerComponents.bind(this);
		this.getControllerComponent = this.getControllerComponent.bind(this);
		this._getRootReducer = this._getRootReducer.bind(this);
		this._createThrowActionMethod = this._createThrowActionMethod.bind(this);
		this._processThrowActionMethod = this._processThrowActionMethod.bind(this);
		this._initMethods = this._initMethods.bind(this);
		this._initStore = this._initStore.bind(this);
		this._initRouter = this._initRouter.bind(this);
		this.getStore = this.getStore.bind(this);
		this._setStore = this._setStore.bind(this);
		this.getState = this.getState.bind(this);
		this.getRouter = this.getRouter.bind(this);
		this.createRouter = this.createRouter.bind(this);
		this.getRouterRoutes = this.getRouterRoutes.bind(this);
		this.createRouterRoutes = this.createRouterRoutes.bind(this);
		this.createEmptyState = this.createEmptyState.bind(this);
		this.cloneState = this.cloneState.bind(this);
		this.run = this.run.bind(this);

		this.afterInit();
	}

	/**
  * PUBLIC METHODS
  */

	/**
  * Controller initialization.
  */


	_createClass(ReduxAppController, [{
		key: 'init',
		value: function init() {
			this._joinComponents();
			this._initStore();
			this._initRouter();
		}

		/**
   * Properties initialization.
   */

	}, {
		key: 'initProperties',
		value: function initProperties() {}

		/**
   * After initialization operations.
   */

	}, {
		key: 'afterInit',
		value: function afterInit() {
			this._initMethods();
		}

		/**
   * Returns the initial app state.
   * @returns Object
   */
		// getStateInitialData() {}

		/**
   * Full list of app actions, i.e. actions handled by the main controller.
   * @returns {Array}
   */

	}, {
		key: 'getActionTypes',
		value: function getActionTypes() {
			return this._action_types;
		}

		/**
   * Returns the controller components.
   * Structure of the return value:
   * {
   *     component_one_key: new SomeControllerComponentOne(),
   *     component_two_key: new SomeControllerComponentTwo()
   * }
   * @returns Object[]
   */

	}, {
		key: 'getControllerComponents',
		value: function getControllerComponents() {
			return [];
		}

		/**
   * Returns the controller component by its key indicated in getControllerComponents() method.
   * @returns {ReduxAppControllerComponent}
   */

	}, {
		key: 'getControllerComponent',
		value: function getControllerComponent(key) {
			return this.getControllerComponents()[key];
		}

		/**
   * Returns the app router. If null is returned, it means that routing is disabled in this app.
   * @returns ReduxAppControllerRouter
   */

	}, {
		key: 'getRouter',
		value: function getRouter() {
			if (this.router === undefined) {
				this.router = this.createRouter();
			}
			return this.router;
		}
		/**
   * Создаёт и возвращет router приложения. Чтобы инициализировать routing в приложении, надо переопределить и вернуть потомка ReduxAppControllerRouter.
   * @returns Object
   */

	}, {
		key: 'createRouter',
		value: function createRouter() {
			return null;
		}

		/**
   * Returns the app routes structure.
   * @returns Object
   */

	}, {
		key: 'getRouterRoutes',
		value: function getRouterRoutes() {
			if (this.router_routes === undefined) {
				this.router_routes = this.createRouterRoutes();
			}
			return this.router_routes;
		}
		/**
   * Creates the app routes structure.
   * @returns Object
   */

	}, {
		key: 'createRouterRoutes',
		value: function createRouterRoutes() {
			return null;
		}

		/**
   * Returns the app store.
   * @returns Object
   */

	}, {
		key: 'getStore',
		value: function getStore() {
			return this.store || {};
		}

		/**
   * Returns the app state.
   * @returns Object
   */

	}, {
		key: 'getState',
		value: function getState() {
			return this.getStore().getState();
		}

		/**
   * Create the app empty state object.
   * @returns Object
   */

	}, {
		key: 'createEmptyState',
		value: function createEmptyState() {
			return {};
		}
		/**
   * Returns the clone of the state object passed as a parameter.
   * @param state The state object to be cloned.
   * @returns Object
   */

	}, {
		key: 'cloneState',
		value: function cloneState(state) {
			var cloned_state = this.createEmptyState();
			var _index = cloned_state.index;

			// To avoid cloning the methods of the state object.
			Object.defineProperties(cloned_state, Object.keys(state).reduce(function (descriptors, key) {
				var new_value = Object.getOwnPropertyDescriptor(state, key);
				if (!$.isFunction(state[key])) {
					descriptors[key] = new_value;
				}
				return descriptors;
			}, {}));

			cloned_state.index = _index;
			return cloned_state;
		}

		/**
   * Renders the root React component of the app.
   */
		// render() {}

		/**
   * Run the controller.
   */

	}, {
		key: 'run',
		value: function run() {
			this.getStore().subscribe(this.render);
			this.render();
		}

		/**
   * PRIVATE METHODS
   */

		/**
   * Converts SOME_ACTION_NAME into SomeActionName.
   * @param underscore_string String with underscore separators.
   * @returns {string}
   * @private
   */

	}, {
		key: '_getCamelCaseFromUnderscore',
		value: function _getCamelCaseFromUnderscore(underscore_string) {
			var parts = underscore_string.toLowerCase().split('_'),
			    capitalized_parts = [];
			var _iteratorNormalCompletion = true;
			var _didIteratorError = false;
			var _iteratorError = undefined;

			try {
				for (var _iterator = parts[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
					var part = _step.value;

					capitalized_parts.push(part.slice(0, 1).toUpperCase() + part.slice(1));
				}
			} catch (err) {
				_didIteratorError = true;
				_iteratorError = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion && _iterator.return) {
						_iterator.return();
					}
				} finally {
					if (_didIteratorError) {
						throw _iteratorError;
					}
				}
			}

			return capitalized_parts.join('');
		}

		/**
   * Returns the root reducer for the app store.
   * @returns {function(this:ReduxAppController)}
   * @private
   */

	}, {
		key: '_getRootReducer',
		value: function _getRootReducer() {
			var initial_state = this.getStateInitialData();
			return function () {
				var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initial_state;
				var action = arguments[1];

				// Iterating action types to check if the given action matches any of them
				var _iteratorNormalCompletion2 = true;
				var _didIteratorError2 = false;
				var _iteratorError2 = undefined;

				try {
					for (var _iterator2 = this.getActionTypes()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
						var action_type = _step2.value;

						if (action_type == action.type) {
							// If we have a matching action type and we have a reducer method for it, then we should call it.
							var reduce_method_name = REDUCE_METHOD_PREFIX + this._getCamelCaseFromUnderscore(action_type);
							if ($.isFunction(this[reduce_method_name])) {
								// We isolate the "type" field of the action from the action data passed through the chain of the action handling methods
								// to avoid erasing its value on any of the stages.
								return this[reduce_method_name](state, action.data);
							}
						}
					}
				} catch (err) {
					_didIteratorError2 = true;
					_iteratorError2 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion2 && _iterator2.return) {
							_iterator2.return();
						}
					} finally {
						if (_didIteratorError2) {
							throw _iteratorError2;
						}
					}
				}

				return state;
			}.bind(this);
		}

		/**
   * Creates a dummy-method that will be used for firing the given action.
   * Return the closure function (data_for_action) { // do things }
   * @param action_type Action type.
   * @param handle_method_name Correspondent action handler method name.
   * @returns {function(this:ReduxAppController)}
   * @private
   */

	}, {
		key: '_createThrowActionMethod',
		value: function _createThrowActionMethod(action_type, handle_method_name) {
			var void_throw_method = function void_throw_method(data) {
				return data;
			};
			return this._processThrowActionMethod(void_throw_method, action_type, handle_method_name);
		}

		/**
   * Processes given action firing method to wrap it into a correct sequence of operations:
   * 1) generation of a correct action object with throwSomeActionName();
   * 2) dispatching action by the store to change the state with reduceOnSomeActionName();
   * 3) call of a corresponding logical action handler handleSomeActionName() if there is one.
   * Returns a closure function (data_for_action) { // do things }
   * @param method Method declared in a controller throwSomeActionName.
   * @param action_type Action type.
   * @param handle_method_name Action handler method name.
   * @returns {function(this:ReduxAppController)}
   * @private
   */

	}, {
		key: '_processThrowActionMethod',
		value: function _processThrowActionMethod(method, action_type, handle_method_name) {
			return function (data_for_action) {
				// Getting the result of action thrower work with the data from the method declared in the controller.
				var action = this._createActionObject(action_type, method(data_for_action));
				// Dispatch the action object we now have.
				this.getStore().dispatch(action);
				// Handling the action if we have a handler.
				if ($.isFunction(this[handle_method_name])) {
					this[handle_method_name](action.data);
				}
			}.bind(this);
		}

		/**
   * Creates the correct action object from the given data.
   * @param action_type Action type.
   * @param data_for_action Action data object.
   * @returns Object
   * @private
   */

	}, {
		key: '_createActionObject',
		value: function _createActionObject(action_type, data_for_action) {
			return {
				type: action_type,
				data: data_for_action
			};
		}

		/**
   * Attempts to add methods corresponding to a given controller component actions into the controller. If fails, returns false, if succeeds — true.
   * @param {ReduxAppControllerComponent} component
   * @param {string[]} action_types Action types to add methods for.
   * @returns {bool}
   * @private
   */

	}, {
		key: '_propagateComponentMethods',
		value: function _propagateComponentMethods(component, action_types) {
			var _this = this;

			var available_action_prefixes = [THROW_METHOD_PREFIX, HANDLE_METHOD_PREFIX, REDUCE_METHOD_PREFIX];

			// Trying to add all the possible action handling methods from a controller component to the controller.
			// Adding only those which are declared in a given component.
			var _iteratorNormalCompletion3 = true;
			var _didIteratorError3 = false;
			var _iteratorError3 = undefined;

			try {
				for (var _iterator3 = action_types[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
					var action_type = _step3.value;

					var method_name_suffix = this._getCamelCaseFromUnderscore(action_type);

					var _iteratorNormalCompletion4 = true;
					var _didIteratorError4 = false;
					var _iteratorError4 = undefined;

					try {
						var _loop = function _loop() {
							var action_prefix = _step4.value;

							var method_name = action_prefix + method_name_suffix;

							if (!$.isFunction(component[method_name])) {
								return 'continue';
							}

							// If a method to be defined is already defined, we should throw an error.
							if (_this[method_name] !== undefined) {
								var error_message = 'Controller init error! A "' + method_name + '" propagated method has already been initialized!';
								_Utils2.default.error('ReduxAppController', error_message);
								return {
									v: false
								};
							}

							// Passing to the parent controller an action handling method, which calls a corresponding controller component method inside.
							_this[method_name] = function () {
								return component[method_name].apply(component, arguments);
							};
						};

						for (var _iterator4 = available_action_prefixes[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
							var _ret = _loop();

							switch (_ret) {
								case 'continue':
									continue;

								default:
									if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
							}
						}
					} catch (err) {
						_didIteratorError4 = true;
						_iteratorError4 = err;
					} finally {
						try {
							if (!_iteratorNormalCompletion4 && _iterator4.return) {
								_iterator4.return();
							}
						} finally {
							if (_didIteratorError4) {
								throw _iteratorError4;
							}
						}
					}
				}
			} catch (err) {
				_didIteratorError3 = true;
				_iteratorError3 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion3 && _iterator3.return) {
						_iterator3.return();
					}
				} finally {
					if (_didIteratorError3) {
						throw _iteratorError3;
					}
				}
			}

			return true;
		}

		/**
   * Attempts to add a controller component into the controller. If fails, returns false, if succeeds, returns a list of action types required by a controller component.
   * @param {ReduxAppControllerComponent} component
   * @returns {bool|string[]}
   * @private
   */

	}, {
		key: '_joinControllerComponent',
		value: function _joinControllerComponent(component) {
			var _action_types;

			var component_actions = component.getActionTypes(),
			    component_required_actions = component.getRequiredActionTypes(),
			    actions_intersection = _lodash2.default.intersection(component_actions, this.getActionTypes());

			// If we try to combine controller action types and see that there are duplicates,
			// we should throw an error and terminate.
			if (actions_intersection.length) {
				var error_message = 'Controller init error! A ' + actions_intersection.toString() + ' part of actions array ' + component_actions.toString() + ' intersects with existing actions!';
				_Utils2.default.error('ReduxAppController', error_message);
				return false;
			}

			// Adding controller component action types into the controller.
			(_action_types = this._action_types).push.apply(_action_types, _toConsumableArray(component_actions));

			// Propagating methods to be taken from a component to the controller.
			if (!this._propagateComponentMethods(component, component_actions)) {
				return false;
			}

			component.setController(this);

			return component_required_actions;
		}

		/**
   * Joins controller components into the controller.
   * @private
   */

	}, {
		key: '_joinComponents',
		value: function _joinComponents() {
			var components = this.getControllerComponents(),
			    required_actions = [];

			// Iterating controller components.
			for (var component_key in components) {
				var component = components[component_key];
				if (component instanceof _ReduxAppControllerComponent2.default) {
					var component_required_actions = void 0;
					if (component_required_actions = this._joinControllerComponent(component)) {
						// Gathering the list of all the action types required by the indicated controller components.
						required_actions.push.apply(required_actions, _toConsumableArray(component_required_actions));
					} else {
						return;
					}
				}
			}

			// If we don't have any of the required actions, we should throw an error.
			var missing_actions = _lodash2.default.difference(_lodash2.default.uniq(required_actions), this.getActionTypes());
			if (missing_actions.length) {
				var error_message = 'Controller init error! The following required actions have not been initialized: ' + missing_actions.toString();
				_Utils2.default.error('ReduxAppController', error_message);
			}
		}

		/**
   * Initializes controller methods.
   * @private
   */

	}, {
		key: '_initMethods',
		value: function _initMethods() {
			var _iteratorNormalCompletion5 = true;
			var _didIteratorError5 = false;
			var _iteratorError5 = undefined;

			try {
				for (var _iterator5 = this.getActionTypes()[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
					var action_type = _step5.value;

					var method_name_suffix = this._getCamelCaseFromUnderscore(action_type),
					    throw_method_name = THROW_METHOD_PREFIX + method_name_suffix,
					    handle_method_name = HANDLE_METHOD_PREFIX + method_name_suffix,
					    reduce_method_name = REDUCE_METHOD_PREFIX + method_name_suffix;

					// Creting or processing the action firing methods.
					this[throw_method_name] = !$.isFunction(this[throw_method_name]) ? this._createThrowActionMethod(action_type, handle_method_name) : this._processThrowActionMethod(this[throw_method_name], action_type, handle_method_name);

					// Binding this object to the reducer methods.
					if ($.isFunction(this[reduce_method_name])) {
						this[reduce_method_name] = this[reduce_method_name].bind(this);
					}

					// Binding this object to the action handling methods.
					if ($.isFunction(this[handle_method_name])) {
						this[handle_method_name] = this[handle_method_name].bind(this);
					}
				}
			} catch (err) {
				_didIteratorError5 = true;
				_iteratorError5 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion5 && _iterator5.return) {
						_iterator5.return();
					}
				} finally {
					if (_didIteratorError5) {
						throw _iteratorError5;
					}
				}
			}
		}

		/**
   * Stores a given store into the controller.
   * @param store_to_set
   * @private
   */

	}, {
		key: '_setStore',
		value: function _setStore(store_to_set) {
			this.store = store_to_set;
		}

		/**
   * Initializes the controller store.
   * @private
   */

	}, {
		key: '_initStore',
		value: function _initStore() {
			this._setStore((0, _redux.createStore)(this._getRootReducer(), (0, _redux.applyMiddleware)(_reduxThunk2.default)));
		}

		/**
   * Initializes the controller router.
   * @private
   */

	}, {
		key: '_initRouter',
		value: function _initRouter() {
			var router = this.getRouter();
			if (router instanceof _ReduxAppControllerRouter.ReduxAppControllerRouter) {
				router.init();
			}
		}
	}]);

	return ReduxAppController;
}();

exports.default = ReduxAppController;