"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ReduxAppControllerComponent = function () {
	function ReduxAppControllerComponent() {
		_classCallCheck(this, ReduxAppControllerComponent);

		this.controller = null;

		this.init = this.init.bind(this);

		this.init();
	}
	/**
  * Controller component initialization.
  */


	_createClass(ReduxAppControllerComponent, [{
		key: "init",
		value: function init() {}
		/**
   * Sets the parent controller into this controller component.
   * @param {ReduxAppController} controller
   * @returns {ReduxAppControllerComponent}
   */

	}, {
		key: "setController",
		value: function setController(controller) {
			this.controller = controller;
			return this;
		}
		/**
   * Returns the parent controller.
   * @returns {ReduxAppController}
   */

	}, {
		key: "getController",
		value: function getController() {
			return this.controller;
		}
		/**
   * Returns the list of app actions handled by this controller component.
   * During the controller compilation these actions will be added into the parent controller.
   * @returns {string[]}
   */

	}, {
		key: "getActionTypes",
		value: function getActionTypes() {
			return [];
		}
		/**
   * Returns the list of actions required to be handled by one of the parent controller components
   * or by the parent controller itself to make this controller component work. In case any of these actions
   * isn't available to be handled the parent controller will throw an error.
   * @returns {string[]}
   */

	}, {
		key: "getRequiredActionTypes",
		value: function getRequiredActionTypes() {
			return [];
		}

		/**
   * Returns the app's store.
   * @returns Object
   */

	}, {
		key: "getStore",
		value: function getStore() {
			return this.getController().getStore();
		}

		/**
   * Returns the app's state.
   * @returns Object
   */

	}, {
		key: "getState",
		value: function getState() {
			return this.getController().getState();
		}
		/**
   * Returns the cloned state object.
   * @param state State object to be cloned.
   * @returns Object
   */

	}, {
		key: "cloneState",
		value: function cloneState(state) {
			return this.getController().cloneState(state);
		}

		/**
   * Returns the app's router.
   * @returns Object
   */

	}, {
		key: "getRouter",
		value: function getRouter() {
			return this.getController().getRouter();
		}
	}]);

	return ReduxAppControllerComponent;
}();

exports.default = ReduxAppControllerComponent;