'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ReduxAppControllerRouter = exports.Router = exports.hashHistory = exports.browserHistory = exports.IndexRedirect = exports.Redirect = exports.IndexRoute = exports.Link = exports.Route = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _Utils = require('./Utils');

var _Utils2 = _interopRequireDefault(_Utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Exporting all react-router components to avoid the need to import all these components separately from react-router.
exports.Route = _reactRouter.Route;
exports.Link = _reactRouter.Link;
exports.IndexRoute = _reactRouter.IndexRoute;
exports.Redirect = _reactRouter.Redirect;
exports.IndexRedirect = _reactRouter.IndexRedirect;
exports.browserHistory = _reactRouter.browserHistory;
exports.hashHistory = _reactRouter.hashHistory;

/**
 * This class serves only one purpose — pass the controller object to all its descendant components.
 */

var Router = exports.Router = function (_ParentRouter) {
	_inherits(Router, _ParentRouter);

	function Router() {
		_classCallCheck(this, Router);

		return _possibleConstructorReturn(this, (Router.__proto__ || Object.getPrototypeOf(Router)).apply(this, arguments));
	}

	_createClass(Router, [{
		key: 'render',
		value: function render() {
			var controller = this.props.controller,
			    createElement = function createElement(Component, props) {
				return _react2.default.createElement(Component, _extends({}, props, { controller: controller }));
			};
			return _react2.default.createElement(
				_reactRouter.Router,
				_extends({}, this.props, { createElement: createElement }),
				this.props.children
			);
		}
	}]);

	return Router;
}(_reactRouter.Router);

var ReduxAppControllerRouter = exports.ReduxAppControllerRouter = function () {
	function ReduxAppControllerRouter() {
		_classCallCheck(this, ReduxAppControllerRouter);

		//super();

		this.history_type = _reactRouter.hashHistory;
		this.history = null;

		this.init = this.init.bind(this);
		this.setHistoryType = this.setHistoryType.bind(this);
		this.getHistory = this.getHistory.bind(this);
	}

	/**
  * Router initialization.
  */


	_createClass(ReduxAppControllerRouter, [{
		key: 'init',
		value: function init() {
			this.history = this.history_type;
		}

		/**
   * Sets the router's history type.
   * @param history_type History object — browserHistory|hashHistory
   * @returns {ReduxAppControllerRouter}
   */

	}, {
		key: 'setHistoryType',
		value: function setHistoryType(history_type) {
			this.history_type = history_type;
			return this;
		}

		/**
   * Returns the router's history object.
   * @returns {browserHistory|hashHistory}
   */

	}, {
		key: 'getHistory',
		value: function getHistory() {
			return this.history;
		}

		/**
   * Moves to the indicated route url.
   * @param url Route url.
   */

	}, {
		key: 'location',
		value: function location(url) {
			this.getHistory().push(url);
		}
	}]);

	return ReduxAppControllerRouter;
}();